#include <stdio.h>

int main() {
    char array[10];
    char string[] = "Hallo!";	/* Groesse wird vom Compiler bestimmt */
    char *s1 = "Welt";
    char *s2;

    /* array = "not OK"; */	/* nicht zulaessig; array ist konstanter Zeiger
				 * => Adresse nicht veraenderbar */

    array[0] = 'A';		/* zulaessig */
    array[1] = '\0';		/* ... und noch mit Null-Byte terminieren */
    printf("array: %s\n", array);

    /* s1[0] = 'b'; */		/* i.a. nicht zulaessig, da die
				 * Speicherflaeche, auf die s1
                        	 * hier zeigt, im READ-ONLY-Bereich ist! */

    s1 = "ok";			/* zulaessig, da Zeiger nicht konstant */
    printf("s1: %s\n", s1);

    s2 = s1;			/* zulaessig, da Zeiger nicht konstant */
    printf("s2: %s\n", s2);

    string[0] = 'X';		/* zulaessig, da nicht im READ-ONLY wg. Array */
    printf("string: %s\n", string);
    printf("sizeof(string): %d\n", sizeof(string));	/* siehe oben */

    return 0;
}
